/*******************************************************************************
 * Copyright (c) 2014, Jan Koester jan.koester@gmx.net
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * Neither the name of the <organization> nor the
 *      names of its contributors may be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *******************************************************************************/

#include <algorithm>
#include <sstream>
#include <chrono>
#include <thread>
#include <iostream>
#include <signal.h>

#include <netplus/socket.h>
#include <netplus/exception.h>

#include "http.h"
#include "exception.h"

#include <cstring>



int main(int /*argc*/, char** argv){
  libhttppp::HttpUrl url(argv[1]);

#ifndef Windows
  signal(SIGPIPE, SIG_IGN);
#endif
  std::unique_ptr<netplus::socket> cltsock;

  try{
      libhttppp::HttpRequest req;
      req.setRequestType(GETREQUEST);
      req.setRequestURL(url.getPath());
      req.setHeaderData("connection")->push_back("keep-alive");
      req.setHeaderData("host")->push_back(url.getHost());
      req.setHeaderData("accept")->push_back("text/json");
      req.setHeaderData("user-agent")->push_back("libhttppp/1.0 (Alpha Version 0.1)");
      libhttppp::HttpClient clt(url);
      std::vector<char> back = clt.Get(req);
      std::cout.write(back.data(),back.size());
  }catch(libhttppp::HTTPException &e){
      std::cerr << e.what() << std::endl;
      return -1;
  }
}

